Page MenuHomePhabricator

Users disagree on what "Blocking Others", "Action Required" and "Waiting on Others" mean, and/or which groups should exist
Closed, ResolvedPublic

Description

The Differential dashboard shows three categories "Blocking Others", "Action Required", and "Waiting on Others". I have suggestions for improvements. I'm sure different people have different takes on this, so please let me know if a mailing list discussion is a better venue for this than a Maniphest task.

The current problems (for me):

  • The English phrase "Action Required" seems like a superset of the phrase "Blocking Others", but the actual list isn't a superset of the other. I feel like even though I now use this dashboard once or twice a day, this oddity still makes my brain stutter for a moment.
  • The "Action Required" list combines "Need to fix" and "Need to close". My state of mind is different when I'm deciding which of those review types I feel like tackling at the moment. It would be nice if they were separate lists. Maybe I'll eventually train my brain to look at the green stripe, but at this point I guess I feel like a separate list would be better.
  • Though the term "Blocking Others" is a nice phrase because it conveys the importance of attending to those reviews, I think "Need to review" makes it more obvious what the group is. (Though maybe I'm wrong about what the "Blocking Others" list includes?)
  • The "Waiting on Others" list combines "Waiting on someone to review my revision" and "Waiting on someone to push a revision I reviewed". I usually care a lot more about finding the first category than the second. Again, even though there's a green stripe, I think it would be nicer if these were separate categories. I even be fine if the second category wasn't shown on the dashboard.

What I think I want is the following four categories:

  • Need to review
  • Need to make changes
  • Need to close
  • Waiting on review

And then maybe the following two additional categories, though I wouldn't mind if these weren't shown on the dashboard:

  • Someone else needs to make changes (I'm either reviewer or CC)
  • Someone else needs to close (I'm either reviewer or CC)

(NOTE: I didn't take the time to figure out precisely what each category covered, so I apologize if I messed that up.)

Event Timeline

cakoose created this task.Nov 21 2013, 10:25 PM
cakoose raised the priority of this task from to Needs Triage.
cakoose updated the task description. (Show Details)
cakoose added a project: Differential.
cakoose added a subscriber: cakoose.

T4055 possibly contemplates a "Need to close, but not yet, because someone else needs to close a dependency first".

epriestley triaged this task as Wishlist priority.May 6 2014, 1:29 PM

We haven't seen many other requests in this vein, and the ones we have seen (T4055, T2511, this) want different things.

In the short term, T3583 (essentially, letting you build your own view as a dashboard) is probably the best attack we have on this.

epriestley renamed this task from Differential dashboard: Making the list of reviews more useful. to Users disagree on what "Blocking Others", "Action Required" and "Waiting on Others" mean, and/or which groups should exist.Feb 22 2016, 8:34 PM
eadler added a project: Restricted Project.Feb 22 2016, 10:10 PM
eadler moved this task from Restricted Project Column to Restricted Project Column on the Restricted Project board.
eadler moved this task from Restricted Project Column to Restricted Project Column on the Restricted Project board.May 13 2016, 6:06 PM
eadler moved this task from Restricted Project Column to Restricted Project Column on the Restricted Project board.May 13 2016, 9:15 PM
epriestley closed this task as Resolved.May 16 2016, 7:21 PM
epriestley claimed this task.

There are now six buckets which are more action oriented (Must Review, Ready to Review, Ready to Land, Ready to Update, Waiting on Review, Waiting on Authors) and bucketing is more flexible.

You can use Responsible Users: exact(yourusername) to create a "Personal" dashboard which excludes revisions you are related to only transitively via a package or project. Likewise, you can use Responsible Users: SomeProject to create a project dashboard.

Accepted revisions with open dependencies now show an "Open Dependencies" marker, but don't drop into a different "Almost Ready to Land" bucket.

Reviewer status is now examined individually (as a function of reviewer relationships) instead of in aggregate (as a function of revision status). In particular, accepting a revision will always kick it out of your "Review" queues.

I am declining to implement "Recent Revisions" (T2511) because "recent" is subjective and we haven't seen other requests for this. I think this request predates ApplicationSearch. You can likely build this query yourself today.

None of this is exactly what anyone wanted. If you don't like it, you can now subclass DifferentialRevisionResultBucket and implement your own bucketing algorithm as an extension.

See T10939 for additional context and discussion.